
(ptime)     ;; initialize gc clock timer


(macro time
   (lambda (l)
      (let ((timed-exp (cadr l)))
	 `(begin 
	     (gc)
	     (let* ([starttimes (ptime)]
		    [gcount (lisp-eval '$gccount$)]
		    [result ,timed-exp])
		(gc)
		(let* [[endtimes (ptime)]
		       (ngcs (- (lisp-eval '$gccount$) gcount))
		       (tot-time (- (car endtimes) (car starttimes)))
		       (gc-time (- (cadr endtimes) (cadr starttimes)))
		       (cpu-time (- tot-time gc-time))]
		   (writeln "cpu time    "  cpu-time)
		   (writeln "gc time     "  gc-time)
		   (writeln "total time  "  tot-time)
		   (writeln "number gc's "  ngcs)
		   (writeln "Result =  " result)))))))


(define code-timer
   (lambda (code)
      (let ((scode (compile code)))
	   (timer (execute scode)))))


(define th-timer
   (lambda (thunk)
      (timer (thunk))))



;;;
;;; 
;;;      		Timer macro
;;;

;;; do a ptime to ensure gc timer/counters have been enabled

(ptime)

(macro deftimer
   (lambda (form)
      (let ((name (cadr form)))
	 `(define ,name (list 0 0 0)))))

(macro start-timer 
   (lambda (l)
      (let ((timer-name (cadr l)))	 
	 `(let* ([starttimes (ptime)])
	     (set! ,timer-name (list (- (car ,timer-name) (car starttimes))
				     (- (cadr ,timer-name) 
					(cadr starttimes))))))))
(macro stop-timer 
   (lambda (l)
      (let ((timer-name (cadr l)))	 
	 `(let* ([stoptimes (ptime)]
		 [total-time (+ (car ,timer-name) (car stoptimes))]
		 [gc-time (+ (cadr ,timer-name) (cadr stoptimes))])
	     (set! ,timer-name (list total-time
				  gc-time
				  (- total-time gc-time)))))))

