; the Scheme top level read-eval-print loop,
; the Scheme file loader,
; and instructions to load the standard macros, functions, and patches
; nothing defined in std.s may be used in this file---so no macros!

; all the hand S-coded definitions are at the head of top.l and std.s

(begin
   (#!set! execute (#!lambda (x) (prim-execute x)))
   (#!set! standard-input (lisp-eval 'keyboard))
   (#!set! standard-output (fluid output-port))
   (#!set! scheme-directory (lisp-eval (quote scheme-directory)))
   (#!set! save-defining-form (#!lambda (x) x))
   (set-fluid! scheme-top-level ; for booting
      (#!lambda ()
	 (newline)
	 (print "--> ")
	 ((#!lambda (x)
	     (#!if (eq? x (quote dump!))
		 (begin (set-fluid! scheme-top-level schemerc-top-level)
			(remove-from-namespace (quote schemerc-top-level))
			(remove-from-namespace (quote pure-load))
			(lisp-eval (quote (syscall 10 'savedlisp))) ; unlink
			(gc)
			(print "beginning dump of 'savedlisp'")
			(newline)
			(lisp-eval (quote (dumplisp))))
		 (display
		    (execute
		       (lisp-eval
			  (cons (quote purcopy*)
				(cons (cons
					 (quote quote)
					 (cons (compile x)
					       nil)) nil)))))))
	  (read))
	 ((fluid scheme-top-level))))
   
   (#!set! schemerc-top-level
      ((#!lambda (loop)
	  (#!set! loop
	     (#!lambda ()
		(newline)
		(print (fluid scheme-prompt))
		(display
		   (execute
		      (compile
			 (save-defining-form (read)))))
		(loop)))
	  (#!lambda ()
	     ((#!lambda (home)
		 (let ((msgfile (concat scheme-directory "scheme.msg")))
		    (#!if (file-exists? msgfile)
			(load msgfile)))
		 (set-fluid! scheme-top-level loop)
		 (#!set! scheme-top-level loop)
		 (declare-constant 'scheme-top-level)
		 (#!if home
		    ((#!lambda (schemerc)
			(#!if (file-exists? schemerc)
			    (load schemerc)
			    nil))
		     (concat home
			(#!if (eq? (lisp-eval (quote host-system))
				 (quote unix))
			    "/.schemerc"
			    (#!if (eq? (lisp-eval (quote host-system)) 
				     (quote vms))
				"schemerc."
				nil))))
		    nil))
	      (lisp-eval (quote 
			    (getenv
			       (cond ((eq host-system 'unix) 'HOME)
				     ((eq host-system 'vms) 'SYS$LOGIN))))))
	     ((fluid scheme-top-level))))
       (quote *)))
   
   
   (#!set! load
      (#!lambda (filename)
	 (((#!lambda (loop)
	      (#!lambda (input-port)
		 (#!if input-port
		    (begin 
		       (#!set! loop
			  (#!lambda (form)
			     (#!if (eq? form (lisp-eval (quote (eof))))
				 (begin (close input-port) t)
				 (begin
				    (execute
				       (compile
					  (save-defining-form form)))
				    (loop (read/port input-port))))))
		       (loop (read/port input-port)))
		    (begin (newline)
			   (print "[Unable to load file ")
			   (print filename)
			   (print "]")
			   (reset)))))
	   (quote *))
	  (open filename (quote read)))))
   
   (#!set! pure-load  ; used during booting---does not save defining-forms
      (#!lambda (filename)
	 (((#!lambda (loop)
	      (#!lambda (input-port)
		 (#!if input-port
		    (begin
		       (#!set! loop
			  (#!lambda (form)
			     (#!if (eq? form (lisp-eval (quote (eof))))
				 (begin (close input-port) t)
				 (begin
				    (execute (compile form))
				    (loop (read/port input-port))))))
		       (loop (read/port input-port)))
		    (begin (newline)
			   (print "[Unable to load file ")
			   (print filename)
			   (print "]")
			   (reset)))))
	   (quote *))
	  (open filename (quote read)))))
   
   (print "[scheme-load std.s]") (newline)
   (pure-load (concat scheme-directory "std.s"))
   
   (print "[scheme-load patches.s]") (newline)
   (pure-load (concat scheme-directory "patches.s"))
   
   (set-fluid! base-environment (genbase))
   )
   
